using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.IO;

namespace Org.Shokai.Gis.Gps
{
    /// <summary>
    /// Sony GPS-CS1K Reader
    /// </summary>
    public class SonyCs1kReader
    {
        private Parser parser;

        public SonyCs1kReader()
        {
            parser = new Parser();
        }

        public GpsDataList ReadFile(FileInfo file)
        {
            int year = int.Parse(file.Name.Substring(2, 4)); // N̓t@CɏĂ
            int month = int.Parse(file.Name.Substring(6, 2));
            int day = int.Parse(file.Name.Substring(8, 2));

            StreamReader sr = new StreamReader(file.FullName);
            String line;
            GpsData gpsData;
            GpsDataList dataList = new GpsDataList();
            while (!sr.EndOfStream) // t@C܂
            {
                line = sr.ReadLine();
                gpsData = parser.parseLine(line);
                gpsData.time = new DateTime(year, month, day, gpsData.time.Hour, gpsData.time.Minute, gpsData.time.Second);
                if (!gpsData.hasError) dataList.Add(gpsData);
            }
            sr.Close();
            return dataList;
        }

        public ArrayList ReadDirectory(DirectoryInfo directory)
        {
            ArrayList dataListList = new ArrayList();
            FileInfo[] files = directory.GetFiles("*.log");
            foreach (FileInfo file in files)
            {
                dataListList.Add(ReadFile(file));
            }
            return dataListList;
        }

    }
}
