using System;
using System.Collections.Generic;
using System.Text;

namespace Org.Shokai.Gis.Gps
{
    /// <summary>
    /// k/씼\񋓑
    /// </summary>
    public enum HemiSpheriumNS
    {
        /// <summary>
        /// k
        /// </summary>
        North,
        /// <summary>
        /// 씼
        /// </summary>
        South
    }

    /// <summary>
    /// /\񋓑
    /// </summary>
    public enum HemiSpheriumEW
    {
        /// <summary>
        /// 
        /// </summary>
        East,
        /// <summary>
        /// 
        /// </summary>
        West
    }

    /// <summary>
    /// GPS Information Data
    /// </summary>
    public class GpsData
    {
        /// <summary>
        /// ox
        /// </summary>
        public double lon = Int32.MinValue; // ܓx
        /// <summary>
        /// ܓx
        /// </summary>
        public double lat = Int32.MinValue; // ox
        /// <summary>
        /// k/씼\񋓑
        /// </summary>
        public HemiSpheriumNS NS;
        /// <summary>
        /// /\񋓑
        /// </summary>
        public HemiSpheriumEW EW;

        /// <summary>
        /// 
        /// </summary>
        public DateTime time;

        public Boolean hasError;
        public GpsData()
        {
            NS = HemiSpheriumNS.North; // k
            EW = HemiSpheriumEW.East; // 
            hasError = false;
            time = new DateTime();
        }

        public override String ToString()
        {
            return "Lon:" + lon + ", Lat:" + lat + ", NS:" + NS + ", EW:" + EW + ", Time:" + time.ToString("yyyy/MM/dd/HH/mm/ss");
        }
    }

}
