using System;
using System.Collections.Generic;
using System.Text;

namespace Org.Shokai.Gis.Gps
{

    /// <summary>
    /// Parse $GPGGA Sentence
    /// </summary>
    class Parser
    {
        public Parser()
        {
        }

        public GpsData parseLine(String line){
            GpsData gpsData = new GpsData();

            // parse Data from GPS
            String[] data = line.Split(',');
            switch (data[0])
            {
                #region case "$CPGGA":
                case "$GPGGA":

                    if (data[1] != "") // 
                    {
                        Double time = Double.Parse(data[1]);
                        int hour = (int)time / 10000;
                        int minute = (int)time%10000 / 100;
                        int second = (int)time % 100;
                        gpsData.time = new DateTime(1, 1, 1, hour, minute, second);

                    }

                    if (data[2] != "") // ܓx
                    {
                        Double value = Double.Parse(data[2]);
                        gpsData.lat = (value % 100)/60 + (int)value / 100;
                    }
                    else
                    {
                        //gpsData.lat = Int32.MinValue;
                        gpsData.hasError = true;
                    }

                    if (data[3] == "N") // k
                    {
                        gpsData.NS = HemiSpheriumNS.North;
                    }
                    else if (data[3] == "S") // 씼
                    {
                        gpsData.lat *= -1; // 
                        gpsData.NS = HemiSpheriumNS.South;
                    }
                    else gpsData.hasError = true;

                    if (data[4] != "") // ox
                    {
                        Double value = Double.Parse(data[4]);
                        gpsData.lon = (value%100)/60 + (int)value / 100;
                    }
                    else
                    {
                        //gpsData.lon = Int32.MinValue;
                        gpsData.hasError = true;
                    }

                    if (data[5] == "E") // 
                    {
                        gpsData.EW = HemiSpheriumEW.East;
                    }
                    else if (data[5] == "W") // 
                    {
                        gpsData.lon *= -1; // o
                        gpsData.EW = HemiSpheriumEW.West;
                    }
                    else gpsData.hasError = true;

                    break;
                #endregion
                default:
                    gpsData.hasError = true;
                    break;
            }
            return gpsData;
        }

    }
}
